'''
Code rédigé par l'équipe FB 13 dans le cadre du cours
GNG 1503 à l'Université d'Ottawa en automne 2023.
'''
!pip install anvil-uplink

import anvil.server
import anvil.media
from keras.preprocessing.image import ImageDataGenerator, load_img
import cv2
import numpy as np
import pandas as pd
from google.colab.patches import cv2_imshow #Seulement utile si le code est executé sur colab, sinon remplacer les fonction cv2_imshow par cv2.imshow

def sort(Mesures, InputCertain):
    '''(list,list)->dataframe
    la présente fonction prends en entrée les mesures en mm des roulements dans le format [DI,DE,H]
    et une autre liste dans le même format avec les mesures connues du roulement et renvoie un dataframe
    des références les plus proches triées.
    '''
    dataframe=pd.read_csv('/content/Roulements.csv')
    noms=['DI','DE','H']
    ÉcartsMax=[3,3,3] #Écarts max en mm entre les mesures et les dimensions réelles
    Connu=[bool(InputCertain[0]),bool(InputCertain[1]),bool(InputCertain[2])] #True si la mesure de la caractéristique est connue (ex: omettre h). L'élément neutre est le 0.
    dataframe['Pourcentage écart']=1
    for i, Cert in enumerate(InputCertain): #Première boucle pour écarter les roulements qui n'ont pas les mesures exactes. Les mesures exactes et mesurées sont en deux boucles par souci de rapidité d'execution.
        if(Connu[i]):
            dataframe=dataframe[abs(dataframe[noms[i]]-Cert)<0.3] #0.3 est l'écart max en mm entre les mesures exactes et les réelles. La raison de cet écart est une inexactitude dans la conversion impérial -> métrique
    for i, mes in enumerate(Mesures):#Boucle pour les dimensions mesurées.
        if( not(Connu[i]) and bool(Mesures[i])):#saute la boucle si la mesure n'a pas été prise (ex:hauteur).
            NomCol='Différence '+str(noms[i])
            dataframe[NomCol]=abs(dataframe[noms[i]]-Mesures[i])
            dataframe=dataframe[(dataframe[NomCol]<=ÉcartsMax[i])]
            dataframe['Pourcentage écart']*=(dataframe[NomCol]/Mesures[i]) #Construit le pourcentage d'écart.
    dataframe=dataframe.sort_values(by='Pourcentage écart')
    dataframe=dataframe.reset_index(drop=True)
    return(dataframe)

def reconnaissance(image,MesConnues):
    '''(image,list)->dataframe
    la présente fonction prends en entrée une image et une liste des mesures entrées par l'utilisateur
    et renvoie un dataframe trié des roulements correspondant.
    Dépendances: Fonction sort().
    '''
    gris=cv2.cvtColor(image,cv2.COLOR_BGR2GRAY) #Greyscale l'image 'image' et l'attribut à variable 'gris'
    ret, seuil =cv2.threshold(gris,50,255,cv2.THRESH_TOZERO) #100-50-175Crée l'image seuil en noir et blanc https://www.youtube.com/watch?v=Wl11eloYVm8&ab_channel=CreepyD
    contours, h=cv2.findContours(seuil,2,1)
    contour_liste=[]
    Rectangle=[]

    for cnt in contours:
        approx=cv2.approxPolyDP(cnt,0.01*cv2.arcLength(cnt,True),True)
        n=len(approx)
        if(n>9) & (cv2.contourArea(cnt)>3000):
          contour_liste.append(cnt)
    gris=cv2.cvtColor(image,cv2.COLOR_BGR2GRAY) #Greyscale l'image 'image' et l'attribut à variable 'gris'
    floue=cv2.GaussianBlur(gris, (5,5),0) #Ces fonctions ne sont pas tout le temps utile à la détection
    Bords=cv2.Canny(floue,50,150)
    ret, seuil =cv2.threshold(gris,50,255,cv2.THRESH_TOZERO)
    contours, h=cv2.findContours(seuil,2,1)
    for cnt in contours:
      approx=cv2.approxPolyDP(cnt,0.01*cv2.arcLength(cnt,True),True)
      n=len(approx)
      if(n==4) and (cv2.contourArea(cnt)>10000):

        Rectangle.append(cnt)


    cnt_trier=sorted(contour_liste,key=cv2.contourArea)
    TrierRect=sorted(Rectangle, key=cv2.contourArea)
    try:
      (x3,y3),(w,h),anglederotation =cv2.minAreaRect(TrierRect[len(TrierRect)-2])
    except:
      print("Erreur: Étalon non détecté")
      (x3,y3),(w,h),anglederotation=(1,1),(1,1),1
    b=(0,0,0)
    #image=cv2.rectangle(image,(int(x3),int(y3)),(int(x3+w),int(y3+h)),b,8) #Sert à montrer l'aire du rectangle pour le débogage.
      #Plus gros cercle
    (x1,y1),radDE=cv2.minEnclosingCircle(cnt_trier[len(cnt_trier)-1])
    DE=radDE*2
      #Plus petit cercle
    (x2,y2), radDI = cv2.minEnclosingCircle(cnt_trier[0])
    DI=radDI*2
    coordonés_centre=(int(x1),int(y1))
    rayonDE=int(radDE)
    rayonDI=int(radDI)
    vert=(0,255,0)
    rouge=(0,0,255)
    epaisseur=20
    image=cv2.circle(image,coordonés_centre,rayonDE,vert,epaisseur)
    image=cv2.circle(image,coordonés_centre,rayonDI,rouge,epaisseur)
    cv2_imshow(image)
    TailleÉtalon=17.0#taille en mm de l'étalon utilisé.
    mmParpx=TailleÉtalon/min(h,w)
    DImm=DI*mmParpx
    DEmm=DE*mmParpx


    rz=cv2.resize(image,(0,0),fx=0.2,fy=0.2)
    dimensions=[DE,DI]
    Mesures=[DImm,DEmm,0]
    Dataframe=sort(Mesures,MesConnues)
    DataframeRef=Dataframe['Désignations'].head(10)
    Valeurs=DataframeRef.to_string(index=False)
    Mesures.append(Valeurs)
    DataframePourc=Dataframe['Pourcentage écart'].head(10)
    Valeurs=DataframePourc.to_string(index=False)
    Mesures.append(Valeurs)
    return(Mesures)

anvil.server.connect("server_VB2SQ7CDCAFGAJM4WKDLWKHT-FLUZCSBZEHNRD7LI")
@anvil.server.callable
def envoyer_dims(list):
    file = list[0]
    MesConnues=list[1]
    print(MesConnues)
    with anvil.media.TempFile(file) as filename:
        pil_image=load_img(filename)
    open_cv_image = np.array(pil_image)
    image_raw=open_cv_image[:,:,::-1].copy()
    dims=reconnaissance(image_raw,MesConnues)
    #print(MesConnues)
    return dims
anvil.server.wait_forever()